`timescale 1ns / 1ps

module main_tsm(VME_A,VME_B, VME_C, 
                FF_A, FF_B, FF_C, 
                SW2,
                A, B, C);

    input [15:0] VME_A;
    input [15:0] VME_B;
    input [15:0] VME_C;
    input [15:0] FF_A;
    input [15:0] FF_B;
    input [15:0] FF_C;
    input [3:0] SW2;
   output [15:0] A;
   output [15:0] B;
   output [15:0] C;

reg [15:0] A;
reg [15:0] B;
reg [15:0] C;

always @(SW2 or VME_A or VME_B or VME_C or 
                    FF_A or FF_B or FF_C )
begin
   case (SW2)
      4'hA, 4'hB:
         begin
            A <= FF_A;
            B <= FF_B;
            C <= FF_C;
         end
      4'hC:
         begin
            A <= FF_A;
            B[7:0] <= FF_B[7:0];
            B[11:8] <= VME_A[15:12];
            B[15:12] <= FF_B[15:12];
            C <= FF_C;
         end
      4'hD:
         begin
            A <= VME_A;
            B[7:0] <= FF_B[7:0];
            B[11:8] <= VME_A[15:12];
            B[15:12] <= FF_B[15:12];
            C <= FF_C;
         end
      default:
         begin
            A <= VME_A;
            B <= VME_B;
            C <= VME_C;
         end
   endcase
end
endmodule
